function [A, Aw, Lt] = findTopEdges(L,numOfEdges)
    % numOfEdges = 10;
    C = triu(L,1);
    [vals,inds] = sort(abs(C(:)), 'descend');
    validInds = inds(find(vals>0));
    if (length(validInds) > numOfEdges)
        validInds = validInds(1:numOfEdges);
    end
    n = length(L);
    [row,col] = ind2sub([n n],validInds);
    A = zeros(n);
    Aw = zeros(n);
    for i=1:length(row)
        A(row(i), col(i)) = 1;
        Aw(row(i), col(i)) = abs(L(row(i), col(i)));
    end
    A = A + A';
    Aw = Aw + Aw';
    Lt = diag(sum(A))-A;
end

