function [Xs, L] = spatio_temporal(X, param)
max_iter = 50;
eps = 1e-4;

alpha = param.alpha;
beta = param.beta;
gamma = param.gama;

M = size(X,2);
N = size(X,1);

% Im = eye(M);
% In = eye(N);
% Imn = eye(M*N);
R = eye(N);
% Z0 = zeros(N);

B = [zeros(M-1,1) eye(M-1);
    zeros(1,M)];

% Td = [];
% for i = 1:M
%     pre = repmat(Z0, 1, i-1);
%     suf = repmat(Z0, 1, M-i-1);
%     if (i == M)
%         tmp = [pre In suf];
%     else
%         tmp = [pre In -R suf];
%     end
%     Td = [Td; tmp];
% end
%
% TdTdT = Td * Td';

Dx = @(X,R,B) X-R*X*B;
dfx = @(X,Dx,Dxy,L,R,B,P,Q,alpha,rho) 2*Dxy-2*R*Dxy*B'+rho*(X-P)+Q+2*alpha*(L*Dx-R*L*X*B'+L*X*B*B');

rho = 1;
Xs = X;
P = rand(N,M);
Q = 0;
Lp = 0;
Xp = 0;
pa.maxit = 200;
for i = 1:max_iter

    % Given X, learn L
    DXs = Dx(Xs,R,B);
    Z = gsp_distanz(DXs').^2;
    [W] = gsp_learn_graph_l2_degrees(alpha/2 *Z, 2*beta, pa);
    W = max(0, W);
    W = N/sum(W,'all') * W;
    L = diag(sum(W))-W;

    % learn X
    %     Lh = Td * kron(Im, L) * Td';
    %     Yh = 2 * TdTdT * vec(X);
    %     Xv = (2 * TdTdT + 2 * alpha * Lh + rho * Imn) \ (vec(rho * P - Q) + Yh);
    %     Xs = reshape(Xv, N, M);

    X0 = zeros(N, M);
    Dx0 = Dx(X0, R, B);
    Dxy0 = Dx(X0-X, R, B);
    dfx0 = dfx(X0, Dx0, Dxy0, L, R, B,P,Q,alpha,rho);

    Dxx = Dx(X, R, B);
    phi = 2*Dxx - 2*R*Dxx*B' + rho*P - Q;

    %     for m = 1:10
    if i == 1
        Xm = X0;
        dfxm = dfx0;
        deltaXm = -dfxm;
    else
        Xm = Xs;
        %           Dxm = Dx(Xm, R, B);
        Dxym = Dx(Xm-X, R, B);
        dfxm = dfx(Xm, Dxm, Dxym, L, R, B,P,Q,alpha,rho);
        deltaXm = -dfxm;
        %             Dxm = Dx(Xm, R, B);
        %             Dxym = Dx(Xm-X, R, B);
        %             dfxm = dfx(Xm, Dxm, Dxym, L, R, B,P,Q,alpha,rho);
    end

    DdltXm = Dx(deltaXm, R, B);
    DdltXmy = Dx(deltaXm-X, R, B);
    dfxDltXm = dfx(deltaXm, DdltXm, DdltXmy, L, R, B,P,Q,alpha,rho);

    mu = - trace(deltaXm' * dfxm) / trace(deltaXm' * (dfxDltXm + phi));

    deltaXmp = deltaXm;

    Xm = Xm + mu * deltaXmp;
    Dxm = Dx(Xm, R, B);
    Dxym = Dx(Xm-X, R, B);
    dfxm = dfx(Xm, Dxm, Dxym, L, R, B,P,Q,alpha,rho);
    deltaXm = -dfxm;

    deltaXm = deltaXm + mu * deltaXmp;
    %     end
    Xs = Xm;

    % learn P
    t = gamma / rho;
    [U, S, V] = svd(Xs + Q/rho);
    SS = zeros(size(S));
    for j = 1:length(diag(S))
        s = S(j,j);
        SS(j,j) = sign(s) * max(abs(s) - t, 0);
    end
    P = U * SS * V';

    Q = Q + rho * (Xs - P);

    if norm(Xs-Xp)/norm(Xp) < eps && norm(L-Lp)/norm(Lp) < eps
        break;
    end

    normsX(i) = norm(Xs);
    normsL(i) = norm(L);

    Xp = Xs;
    Lp = L;

end

% subplot(2,1,1);
% plot(normsX);
% 
% subplot(2,1,2);
% plot(normsL);

end

